# --- [ entry.py ] --------------------------------------------------------

import tkinter as Tk
import valEntrys as vE

# -------------------------------------------------------------------------
def format_Eur(value):
    """ Formatiert eine Float-Variable mit Tausendertrennzeichen '.'
    und Komma als Dezmaltrenner """
   
    t = round(value,2)          
    if t == 0:
        return("0.00 €")
    t = str(t)
        
    if t.find('.') == (len(t) -2):
        t = t + "0 €"
    else:
        t = t + " €"

    while True:
        i = t.find('.')
        if i < 4:
            break
        t = t[:i-3] + '.' + t[i-3:]

    return(t[:-5] + ',' + t[-4:])

# ------------------------------------------------------------------------
def txt1_edit(event):
    """ Schreibt den Wert des Entry1 in die
        StringVar für txt1 """
    txt1_var.set(entry1_var.get())

# -----------------------------------------------------------------------
def txt2_edit(event):
    """ Liest den Wert aus dem Entry2 aus,
        versucht den Wert in ein Integer umzuwandeln
        Gelingt das nicht, wird "error" nach txt2_var geschrieben  """
    i = entry2_var.get()
    try:
        if len(i) > 0:
            z = int(i)   
        
    except:
        i = "error"
        txt2.bell()
        
    txt2_var.set(i)

# -------------------------------------------------------------------------
def txt3_edit(event):
    txt3_var.set(txt3.getresult())

# -------------------------------------------------------------------------
def txt4_edit(event):
    txt4_var.set(format_Eur(txt4.getresult()))
    
# -------------------------------------------------------------------------
def txt5_edit(event):
    txt5_var.set(txt5.getresult())

# -------------------------------------------------------------------------
top = Tk.Tk()
top.title("Entry und Validierung")
top.resizable(width = False, height = False) # Größe nicht veränderbar

frm1 = Tk.LabelFrame(top, text = "Labels, Entrys und StringVars", width = 600, height = 20)
frm1.grid(column = 0, row = 0, padx = 5, pady = 5, sticky = "nsew")

entry1_var = Tk.StringVar()
entry2_var = Tk.StringVar()

txt1_var = Tk.StringVar()
txt2_var = Tk.StringVar()
txt3_var = Tk.StringVar()
txt4_var = Tk.StringVar()
txt5_var = Tk.StringVar()

# Spalte 0

txt1 = Tk.Label(frm1, text ="tk.Entry", width = 18, anchor = "e")
txt1.grid(column = 0, row = 0, padx = 5, pady = 5, sticky = "nsew")

txt2 = Tk.Label(frm1, text ="tk.Entry + Prüfung", width = 18, anchor = "e")
txt2.grid(column = 0, row = 1, padx = 5, pady = 5, sticky = "nsew")

txt3 = Tk.Label(frm1, text ="IntegerEntry", width = 18, anchor = "e")
txt3.grid(column = 0, row = 2, padx = 5, pady = 5, sticky = "nsew")

txt4 = Tk.Label(frm1, text ="FloatEntry", width = 18, anchor = "e")
txt4.grid(column = 0, row = 3, padx = 5, pady = 5, sticky = "nsew")

txt5 = Tk.Label(frm1, text ="MaxLengthEntry [=8]", width = 18, anchor = "e")
txt5.grid(column = 0, row = 4, padx = 5, pady = 5, sticky = "nsew")

# Spalte 2

lb1  = Tk.Label(frm1, textvariable = txt1_var, width = 18, anchor = "e")
lb1.grid(column = 2, row = 0, padx = 5, pady = 5, sticky = "nsew")

lb2  = Tk.Label(frm1, textvariable = txt2_var, width = 18, anchor = "e")
lb2.grid(column = 2, row = 1, padx = 5, pady = 5, sticky = "nsew")

lb3  = Tk.Label(frm1, textvariable = txt3_var, width = 18, anchor = "e")
lb3.grid(column = 2, row = 2, padx = 5, pady = 5, sticky = "nsew")

lb4  = Tk.Label(frm1, textvariable = txt4_var, width = 18, anchor = "e")
lb4.grid(column = 2, row = 3, padx = 5, pady = 5, sticky = "nsew")

lb5  = Tk.Label(frm1, textvariable = txt5_var, width = 18, anchor = "e")
lb5.grid(column = 2, row = 4, padx = 5, pady = 5, sticky = "nsew")

# Spalte 1

txt1  = Tk.Entry(
                frm1,                       # das Parent-Window
                relief = "sunken",          # [flat,solid, sunken, raised, groove]
                textvariable = entry1_var,  # die steuernde Variabel
                width = 10                  # die Breite des Eingabefeldes
                )

txt1.grid(column = 1, row = 0, padx = 5, pady = 5, sticky = "new")
#txt1.bind("<Any-KeyPress>", txt1_edit)
txt1.bind("<Any-KeyRelease>", txt1_edit)


txt2  = Tk.Entry(
                frm1,                       
                relief = "sunken",            
                textvariable = entry2_var,
                width = 10                  
                )

txt2.grid(column = 1, row = 1, padx = 5, pady = 5, sticky = "new")
txt2.bind("<Any-KeyRelease>", txt2_edit)

txt3  = vE.IntegerEntry(
                frm1,       
             #  value = 0,
                relief = "sunken",
                width = 10, 
                )

txt3.grid(column = 1, row = 2, padx = 5, pady = 5, sticky = "new")
txt3.bind("<Any-KeyRelease>", txt3_edit)


txt4  = vE.FloatEntry(
                frm1,   
            #   value = 12.34,              # Initwert
                relief = "sunken",
                width = 10,       
                )

txt4.grid(column = 1, row = 3, padx = 5, pady = 5, sticky = "new")
txt4.bind("<Any-KeyRelease>", txt4_edit)


txt5  = vE.MaxLengthEntry(
                frm1,                       
                maxlength = 8,              # Längenbegrenzung des Eingabestring
                to_upper = True,            # Zeichen in Großschreibung umwandeln
                typ ="a",                   # 'n'=numerisch, 'a'=alpha, ''=alles
                relief = "sunken",
                width = 10,       
                )

txt5.grid(column = 1, row = 4, padx = 5, pady = 5, sticky = "new")
txt5.bind("<Any-KeyRelease>", txt5_edit)


txt5.focus_set()

top.mainloop()

# --- [ eof ] --------------------------------------------------------------
